////////////////////////////////////////////////////////////////////
// |Ԉێ̋wKiRPUq^V~[Vj
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <direct.h>
#include <math.h>
#include <omp.h>

#include "Vector3.h"
#include "RK4_Nbody.h"
////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//͈̔
double t_min = 0;
double t_max = 5.0;
double dt = 0.001;
//d͉x
double g = 10.0;
//Ђ̒
double L = 1.0;

//O͂̑傫
double fx_ext_max = 0;//5000.0;
double fx_ext_min = 0;//-5000.0;

//x̍ől
double V0 = 1.0;

//d͉xxNg
Vector3 vec_g = Vector3(0, 0, -g);
//
double m_box = 100.0;
double m = 1.0;

//zPʃxNg
Vector3 z_hat(0, 0, 1);
Vector3 y_hat(0, 1, 0);

//␳p[^
double compensationK = 0.0; //␳΂˒eW
double compensationGamma = 0.0; //␳SRW

int error = 0;
////////////////////////////////////////////////////////////////////
// qNX
////////////////////////////////////////////////////////////////////
class Particles : public RK4_Nbody {
private:
public:
	//
	double fx = 0;
	double fx_ext = 0;

	//RXgN^
	Particles(int _N, double _dt) : RK4_Nbody(_N, _dt) {}

	//fXgN^
	~Particles() {
	}

	void A(double t, Vector3 *rs, Vector3 *vs, Vector3 *out_as) {
		for (int i = 0; i < N; i++) {
			out_as[i].set(0, 0, 0);
		}

		Vector3 a_box;
		a_box.set(fx / m_box, 0, 0);

		//xNg
		Vector3 vec_L = rs[1] - rs[0];
		//Αx
		Vector3 v_ij = vs[1] - vs[0];

		//O
		Vector3 a1_ext(fx_ext / m, 0, 0);
		//
		Vector3 vec_S = vec_L / (pow(vec_L.dot(z_hat), 2) / m_box - (m + m_box) / (m * m_box) * vec_L.lengthSq()) *
			(v_ij.lengthSq() + vec_g.dot(vec_L) + a1_ext.dot(vec_L) - a_box.dot(vec_L));

		double Sz = vec_S.dot(z_hat);

		if (vec_L.length() > 1.1) {
			std::cout << t << " " << vec_L.length() << std::endl;
			std::cout << t << " " << rs[1].x << " " << rs[1].z << std::endl;
		}

		//␳
		Vector3 hatL = vec_L.clone().normalize();
		//␳΂˒e
		Vector3 fk = hatL.clone() * (-compensationK * (hatL.length() - L));
		//x␳
		Vector3 barV = v_ij.clone();
		//␳SR
		Vector3 fgamma = hatL.clone() * (-compensationGamma * barV.dot(hatL));

		//Ԃ։x
		out_as[0] = a_box - vec_S / m_box + Sz * z_hat / m_box - fk / m_box + fgamma / m_box;
		//Uq։x
		out_as[1] = vec_g + vec_S / m + a1_ext + fk / m - fgamma / m;

	};
};


////////////////////////////////////////////////////////////////////
// QwK
////////////////////////////////////////////////////////////////////
//wK
const int Episode = 20000;
//όvZ̊wK
const int ave_span = Episode / 100;
//wK
double eta = 0.01;
//
double gamma = 1.0;
//×~
double epsilon = 1.0;

//
const int N_f_box = 5;//2;
const int N_theta = 21;//4;
const int N_omega = 7;//4;
const int N_x0 = 7;//4;
const int N_vx1 = 7;//4;

//sԊԊu
double interval = 0.05;

const int averageNum = 100;
const int parallelNum = 10;

//sl֐
double Q[averageNum][N_f_box][N_theta][N_omega][N_x0][N_vx1];
//sl֐f[^ǂݍ
//#define LOAD_Q
//std::string load_file_name = "output_1/20180727-BestQ_5_21_7_7_7.txt"; 

double f_box_min = -20.0 * m_box;
double f_box_max = 20.0 * m_box;
double theta_min = -180.0;
double theta_max = 180.0;
double omega_min = -3.0;
double omega_max = 3.0;
double x0_min = -5.0;
double x0_max = 5.0;
double vx1_min = -5.0;
double vx1_max = 5.0;

int getX0index(Particles& particles) {
	double _x0 = particles.rs[0].x;

	//Ԃ̈ʒu
	for (int j = 0; j < N_x0-1; j++) {
		double x0 = x0_min + (x0_max - x0_min) / double(N_theta-2) * j;
		if (_x0 < x0) {
			return j;
		}
	}
	return N_x0 - 1;
}
int getVx0index(Particles& particles) {
	double _vx1 = particles.vs[1].x;

	//̑x
	for (int j = 0; j < N_vx1 - 1; j++) {
		double vx1 = vx1_min + (vx1_max - vx1_min) / double(N_vx1 - 2) * j;
		if (_vx1 < vx1) {
			return j;
		}
	}
	return N_vx1 - 1;
}

int getThetaindex(Particles& particles) {
	double _theta;
	double z = particles.rs[1].z - particles.rs[0].z;
	double x = particles.rs[1].x - particles.rs[0].x;
	double arcsin = asin(x / L) / M_PI * 180.0;

	if (z >= 0) {
		_theta = arcsin;
	}
	else {
		if (x >= 0) _theta = 180.0 - arcsin;
		else         _theta = -180.0 - arcsin;
	}

	//̈ʒuipxj
	for (int j = 0; j < N_theta - 1; j++) {
		double theta = theta_min + (theta_max - theta_min) / double(N_theta - 2) * j;
		if (_theta < theta) {
			return j;
		}
	}
	return N_theta - 1;
}
int getOmegaindex(Particles& particles) {
	double _vx = particles.vs[1].x - particles.vs[0].x;
	double _vz = particles.vs[1].z - particles.vs[0].z;
	double v = sqrt( _vx * _vx + _vz * _vz );

	double _omega = v / L;
	if (_vx < 0) _omega *= -1.0;
	//̊px
	for (int j = 0; j < N_omega-1; j++) {
		double omega = omega_min + (omega_max - omega_min) / double(N_omega-2) * j;
		if (_omega < omega) {
			return j;
		}
	}
	return N_omega - 1;
}

//EsV
double r_success = 0.0;
double r_failure = 0.0;

//ϊi[p
double probabilityOfSuccess[averageNum][Episode / ave_span + 1];
int timesOfSuccess[averageNum];

void readQfunction(std::ifstream &if_Qfunction) {
	std::string str;
	int flag = 0;

	int n_theta = 0;
	int n_omega = 0;
	int n_x0 = 0;
	int n_vx1 = 0;


	while (getline(if_Qfunction, str)) {
		flag = 0;
		if (str.find("#state") != std::string::npos) flag = 1;
		if (str.find("#action") != std::string::npos) flag = 2;
		if (flag == 0 && str.find("#") != std::string::npos) continue;

		if (flag == 2) {

			std::istringstream iss(str);
			std::string s;
			int n_f_box = 0;

			//std::cout << "" << n_theta << " " << n_omega << " " << n_x0 << std::endl;

			while (iss >> s) {
				if (s == "#action:") continue;

				for (int i = 0; i < averageNum; i++) {

					Q[i][n_f_box][n_theta][n_omega][n_x0][n_vx1] = atof(s.c_str());

					//std::cout << atof(s.c_str()) << " ";

				}

				n_f_box++;

			}
			//std::cout << std::endl;

			n_vx1++;
			if (n_vx1 == N_vx1) {
				n_vx1 = 0;
				n_x0++;
			}
			if (n_x0 == N_x0) {
				n_x0 = 0;
				n_omega++;
			}
			if (n_omega == N_omega) {
				n_omega = 0;
				n_theta++;
			}

		}
	}

}

////////////////////////////////////////////////////////////////////
// C֐
////////////////////////////////////////////////////////////////////
int main(void) {
#ifdef _OPENMP
	std::cout << "OpenMP : Enabled (Max # of threads = " << omp_get_max_threads() << ")" << std::endl;
	omp_set_num_threads(parallelNum);
#endif


#ifdef LOAD_Q
	// t@Co̓Xg[̏
	std::ifstream if_Qfunction;
	if_Qfunction.open(load_file_name.c_str());
	if (!if_Qfunction.fail()) {
		readQfunction(if_Qfunction);
	}
	else {
		std::cout << "t@CI[vɎs܂:" << load_file_name.c_str() << std::endl;
	}
#endif

	//tH_̐
	_mkdir("output");

	std::random_device rnd; //񌈒Iȗ
	std::mt19937 mt;        //32rbgŃZkEcCX^
	mt.seed(rnd());         //̎^
	std::uniform_real_distribution<> rand_real_0_1(0, 1.0); //urand_real_0_1(mt)vPsłP̗𐶐

#pragma omp parallel for
	for (int ave = 0; ave < averageNum; ave++) {
		//QNb^IuWFNg̐
		Particles particles(2, dt);

		double epsilon = 1.0;
		double eta = 0.0;

		int success = 0;
		for (int episode = 0; episode <= Episode; episode++) {

			int ebase = Episode * 0.9;
			if (episode < ebase) {
				//X×~߂
				epsilon = 0.5 + 0.5 * double(episode) / double(ebase);
				eta = 0.1;
			}
			else {
				epsilon = 1.0;
				eta = 0.00;
			}

#pragma omp critical
			if (episode % 1000 == 0) {
				std::cout << "episode:" << ave << "-" << episode << std::endl;
			}

			double v0 = 2.0 * V0 * (0.5 - rand_real_0_1(mt));

			//ʒuxNgƑxxNg
			particles.rs[0].set(0, 0, L);
			particles.vs[0].set(0, 0, 0);
			if(episode%2==0) {
				particles.rs[1].set(0, 0, 2*L);
				particles.vs[1].set(v0, 0, 0);
			}
			else {
				particles.rs[1].set(0, 0, 0);
				particles.vs[1].set(0, 0, 0);
			}

			double dQ_ave = 0;
			//sCfbNX
			int n_f_box;
			int n_theta_now;
			int n_omega_now;
			int n_x0_now;
			int n_vx1_now;

			double r_max = 0;

			int M = round((t_max - t_min) / dt);
			for (int i = 0; i <= M; i++) {
				double t = i * dt;

				//O͂^
				double p = dt;//PbɂP
				if ( p > rand_real_0_1(mt)) {
					particles.fx_ext = fx_ext_min + (fx_ext_max - fx_ext_min) * rand_real_0_1(mt);
				}
				else {
					particles.fx_ext = 0;
				}

				if (i == 0) {

					//̏Ԃc
					n_theta_now = getThetaindex(particles);
					n_omega_now = getOmegaindex(particles);
					n_x0_now = getX0index(particles);
					n_vx1_now = getVx0index(particles);

					//^͂͂OƂȂCfbNX^
					n_f_box = N_f_box/2;

					//Ԃ֗͂^
					particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / double(N_f_box-1);

				}
				else if (i % int(interval / dt) == 0) {

					//s̏Ԃc
					int n_theta_next = getThetaindex(particles);
					int n_omega_next = getOmegaindex(particles);
					int n_x0_next = getX0index(particles);
					int n_vx1_next = getVx0index(particles);

					//̌vZïʒuGlM[j
					double v2 = pow(particles.vs[1].x, 2) + pow(particles.vs[1].z, 2);

					double r = m * g * particles.rs[1].z - 1.0 / 2.0 * pow(particles.rs[0].x, 2) * 5.0;

					if ((N_theta - 1) / 4 < n_theta_now && n_theta_now < 3 * (N_theta - 1) / 4) {
						r -= 1.0 / 2.0 * m * v2;
					}
					else {
						r += 1.0 / 2.0 * m * v2;
					}
						
					//
					//if (particles.rs[1].z < 0 ) {
					//	r += r_failure;
					//}

					//
					if (i == M) {
						if (particles.rs[1].z > L*1.95) {
							success++;
							timesOfSuccess[ave]++;
							r += r_success;
						}
					}

					double maxQ = -10000;
					for (int j = 0; j < N_f_box; j++) {
						if (maxQ < Q[ave][j][n_theta_next][n_omega_next][n_x0_next][n_vx1_next]) {
							maxQ = Q[ave][j][n_theta_next][n_omega_next][n_x0_next][n_vx1_next];
						}
					}

					double dQ = (r + gamma * maxQ - Q[ave][n_f_box][n_theta_now][n_omega_now][n_x0_now][n_vx1_now]);
					//sl֐̍XV
					Q[ave][n_f_box][n_theta_now][n_omega_now][n_x0_now][n_vx1_now] = Q[ave][n_f_box][n_theta_now][n_omega_now][n_x0_now][n_vx1_now] + eta * dQ;


					////////////////////////////////////////////////////
					//̍švZX
					////////////////////////////////////////////////////
					n_theta_now = n_theta_next;
					n_omega_now = n_omega_next;
					n_x0_now = n_x0_next;
					n_vx1_now = n_vx1_next;

					maxQ = -1000000;
					int n_f_box_max = -10000;
					for (int j = 0; j < N_f_box; j++) {
						if (maxQ < Q[ave][j][n_theta_now][n_omega_now][n_x0_now][n_vx1_now]) {
							maxQ = Q[ave][j][n_theta_now][n_omega_now][n_x0_now][n_vx1_now];
							n_f_box_max = j;
						}
					}

					//wK̏ꍇimaxQ=0j
					if (abs(maxQ) < 0.001 || n_f_box_max == -10000) n_f_box_max = int(floor(N_f_box * rand_real_0_1(mt)));

					if (rand_real_0_1(mt) < epsilon) {
						//s͍ő剿lsɌ
						n_f_box = n_f_box_max;
					}
					else {
						//s̓_Ɍ
						n_f_box = int(floor(N_f_box * rand_real_0_1(mt)));
					}

					//Ԃ֗͂^
					particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / double(N_f_box - 1);

					//Gs\[hI
					if (particles.rs[1].z < 0 ) {
						//std::cout << ":" << t << "[s]" << particles.rs[1].z << std::endl;
						break;
					}

					double _L = pow(particles.rs[0].x - particles.rs[1].x,2) + pow(particles.rs[0].z - particles.rs[1].z,2);

					if (_L > 1.1) {
						//std::cout << "b" << std::endl;
						error++;
						break;
					}

				}

				//QENb^@ɂ鎞ԔW
				particles.timeEvolution(t);

				for (int n = 0; n < 2; n++) {
					//ʒu̍XV
					particles.rs[n] = particles.rs[n] + particles.drs[n];
					//x̍XV
					particles.vs[n] = particles.vs[n] + particles.dvs[n];
				}

			}
			if (episode % ave_span == 0) {

				probabilityOfSuccess[ave][episode / ave_span] += double(success) / ave_span;

				success = 0;
			}

		}
	}

	//LO̍쐬
	int ranking[averageNum];
	bool ranking_flag[averageNum];
	for (int i = 0; i < averageNum; i++) {
		ranking_flag[i] = false;
	}
	for (int i = 0; i < averageNum; i++) {
		int _times = -1;
		int _ave;
		for (int j = 0; j < averageNum; j++) {

			if (ranking_flag[j]) continue;
			if (_times < timesOfSuccess[j]) {
				_times = timesOfSuccess[j];
				_ave = j;
			}
		}
		ranking[i] = _ave;
		ranking_flag[_ave] = true;
	}

	std::cout << "---------ʁi" << Episode << "wKj-e" << error <<"--------" << std::endl;
	for (int i = 0; i < averageNum; i++) {

		std::cout << i + 1 << " " << timesOfSuccess[ranking[i]] << "񐬌inum:" << ranking[i] << "j" << std::endl;

	}


	//t@C̐ݒ
	std::ostringstream filename1;
	filename1 << "output/20180727-ProbabilityOfSuccess_" << N_f_box << "_" << N_theta << "_" << N_omega << "_" << N_x0 << "_" << N_vx1 << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs1(filename1.str());

	ofs1 << "#x:wK" << std::endl;
	ofs1 << "#y:" << std::endl;
	//ofs1 << "#legend:  " << std::endl;
	ofs1 << "#yrange:0 1 0.1" << std::endl;
	ofs1 << "#showLines: true true true true true" << std::endl;
	ofs1 << "#showMarkers: false false false false false" << std::endl;
	ofs1 << "#fills: false false" << std::endl;

	for (int i = 0; i <= Episode / ave_span; i++) {
		double p = 0;
		for (int j = 0; j < averageNum; j++) {
			p += probabilityOfSuccess[j][i] / averageNum;
		}
		ofs1 << i * ave_span;
		ofs1 << " " << probabilityOfSuccess[ranking[0]][i];
//		ofs1 << " " << probabilityOfSuccess[ranking[1]][i];
//		ofs1 << " " << probabilityOfSuccess[ranking[2]][i];
		ofs1 << " " << probabilityOfSuccess[ranking[averageNum - 1]][i];
		ofs1 << " " << p << std::endl;
	}
	ofs1.close();

	///////////////////////////////////////////////////////////
	// łwKi񂾋@Bɂ鐧̗lq̋L^
	///////////////////////////////////////////////////////////
	int maxTop_rank = 0;
	int rank_maxTop = 0;
	std::ostringstream data0;
	std::ostringstream data1;
	std::ostringstream data2;
	for (int rank = 0; rank < averageNum; rank++) {

		data0.str(""); data0.clear(std::stringstream::goodbit);
		data1.str(""); data1.clear(std::stringstream::goodbit);
		data2.str(""); data2.clear(std::stringstream::goodbit);

		int top = 0;

		//QNb^IuWFNg̐
		Particles particles(2, dt);
		double v0 = V0;

		//ʒuxNgƑxxNg
		particles.rs[0].set(0, 0, L);
		particles.vs[0].set(0, 0, 0);
		particles.rs[1].set(0, 0, 0);
		particles.vs[1].set(0, 0, 0);

		//sCfbNX
		int n_f_box;
		int n_theta_now;
		int n_omega_now;
		int n_x0_now;
		int n_vx1_now;

		double maxV = 0;

		int M = round((t_max - t_min) / dt) * 4;
		for (int i = 0; i <= M; i++) {
			double t = i * dt;

			//O͂^
			double p = dt;//PbɂP
			if (p > rand_real_0_1(mt)) {
				particles.fx_ext = fx_ext_min + (fx_ext_max - fx_ext_min) * rand_real_0_1(mt);
			}
			else {
				particles.fx_ext = 0;
			}

			if (i % int(interval / dt) == 0) {

				//s̏Ԃc
				int n_theta_next = getThetaindex(particles);
				int n_omega_next = getOmegaindex(particles);
				int n_x0_next = getX0index(particles);
				int n_vx1_next = getVx0index(particles);

				////////////////////////////////////////////////////
				//̍švZX
				////////////////////////////////////////////////////
				n_theta_now = n_theta_next;
				n_omega_now = n_omega_next;
				n_x0_now = n_x0_next;
				n_vx1_now = n_vx1_next;

				double maxQ = -1000000;
				int n_f_box_max = -10000;
				for (int j = 0; j < N_f_box; j++) {
					if (maxQ < Q[ranking[rank]][j][n_theta_now][n_omega_now][n_x0_now][n_vx1_now]) {
						maxQ = Q[ranking[rank]][j][n_theta_now][n_omega_now][n_x0_now][n_vx1_now];
						n_f_box_max = j;
					}
				}

				//wK̏ꍇ
				if (n_f_box_max == -10000) n_f_box_max = int(floor(N_f_box * rand_real_0_1(mt)));

				if (rand_real_0_1(mt) < epsilon) {
					//s͍ő剿lsɌ
					n_f_box = n_f_box_max;
				}
				else {
					//s̓_Ɍ
					n_f_box = int(floor(N_f_box  * rand_real_0_1(mt)));
				}

				//Ԃ֗͂^
				particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / double(N_f_box - 1);

			}
		
			
			//ofs << t << " " << particles.rs[0].x << " " << particles.rs[0].y << " " << particles.rs[0].z << " " << particles.rs[1].x << " " << particles.rs[1].y << " " << particles.rs[1].z << std::endl;
			if (i % 100 == 0) data1 << particles.rs[0].x << " " << particles.rs[0].z << std::endl;
			if (i % 100 == 0) data2 << particles.rs[1].x << " " << particles.rs[1].z << std::endl;
			if (i % 100 == 0) data0 << t << " " <<  particles.rs[1].x << " " <<  particles.rs[1].z << " " << particles.vs[1].x << std::endl;

			//QENb^@ɂ鎞ԔW
			particles.timeEvolution(t);

			for (int n = 0; n < 2; n++) {
				//ʒu̍XV
				particles.rs[n] = particles.rs[n] + particles.drs[n];
				//x̍XV
				particles.vs[n] = particles.vs[n] + particles.dvs[n];
			}

			if (particles.rs[1].z > L*1.95 ) top++;

		}

		if (maxTop_rank < top && particles.rs[1].x < 5.0) {
			maxTop_rank = top;
			rank_maxTop = rank;

			double E2 = 1.0 / 2.0 * m * particles.vs[1].lengthSq() + m * g * particles.rs[1].z;

			double _L01 = Vector3::distance(particles.rs[1], particles.rs[0]);
			std::cout << "L=" << (_L01 - L) << " E=" << E2 << std::endl;

			//t@C̐ݒ
			std::ostringstream filename;
			filename << "output/20180727-HorizontalFreePendulum_" << N_f_box << "_" << N_theta << "_" << N_omega << "_" << N_x0 << "_" << N_vx1 << ".txt";
			// t@Co̓Xg[̏
			std::ofstream ofs(filename.str());

			ofs << "#x:[s]" << std::endl;
			//ofs << "#y:xW[m]" << std::endl;
			ofs << "#legend: xW zW" << std::endl;
			ofs << "#showLines: true true true true false false" << std::endl;
			ofs << "#showMarkers: false false false false true true" << std::endl;
			ofs << "#fills: false false false false" << std::endl;

			//ofs << "#dataset:1 " << std::endl;
			//ofs << data1.str() << std::endl;
			//ofs << "" << std::endl;
			//ofs << "#dataset:2 " << std::endl;
			//ofs << data2.str() << std::endl;

			ofs << data0.str() << std::endl;

			ofs.close();
		}
	}


	//t@C̐ݒ
	std::ostringstream filename2;
	filename2 << "output/20180727-BestQ_" << N_f_box << "_" << N_theta << "_" << N_omega << "_" << N_x0 << "_" << N_vx1 << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs2(filename2.str());
	
	for (int j0 = 0; j0 < N_theta; j0++) {
		for (int j1 = 0; j1 < N_omega; j1++) {
			for (int j2 = 0; j2 < N_x0; j2++) {
				for (int j3 = 0; j3 < N_vx1; j3++) {
					ofs2 << "#state: " << j0 << " " << j1 << " " << j2 << " " << j3 << std::endl;
					ofs2 << "#action:";
					for (int j4 = 0; j4 < N_f_box; j4++) {
						ofs2 << " " << Q[ranking[rank_maxTop]][j4][j0][j1][j2][j3];
					}
					ofs2 << std::endl;
				}
			}
		}

	}
	ofs2.close();



	std::cout << "finished" << std::endl;

	int a;
	std::cin >> a;
	return a;

}

/*
gccRpC
g++ -c Vector3.cpp -std=c++14 -O2
g++ -c RK4_Nbody.cpp -std=c++14 -O2
g++ -c main.cpp -std=c++14 -O2
g++ main.o Vector3.o RK4_Nbody.o
*/
